# Released under the MIT License. See LICENSE for details.
#
"""Auto-generated sender module. Do not edit by hand."""

from __future__ import annotations

from typing import TYPE_CHECKING, overload

from efro.message import MessageSender, BoundMessageSender

if TYPE_CHECKING:
    from typing import Any, Awaitable
    from baserver.msg.basntobamaster import (
        ForwardedClientMessage,
        LoginProxyRequestInternalMessage,
        LoginProxyStateQueryInternalMessage,
        LoginProxyCompleteInternalMessage,
        AccountSessionReleaseInternalMessage,
        AccountSessionRegisterChannelMessage,
        GetTestCloudBuildModeMessage,
        AccountSessionDeleteChannelsMessage,
        LogMessage,
        ServerNodeStatsMessage,
        TestCommResponseMessage,
        ServerNodeStatsSparseMessage,
        SignInInternalMessage,
        CloudFilesExistQueryMessage,
        CloudBuildResultsMessage,
        ForwardedClientResponse,
        LoginProxyRequestInternalResponse,
        LoginProxyStateQueryInternalResponse,
        AccountSessionRegisterChannelResponse,
        SignInInternalResponse,
        CloudFilesExistQueryResponse,
    )
    from efro.message import Message, StringResponse, BoolResponse, Response


class BAMasterMessageSender(MessageSender):
    """Protocol-specific sender."""

    def __init__(self) -> None:
        from baserver.msg.basntobamaster import get_protocol

        protocol = get_protocol()
        super().__init__(protocol)

    def __get__(
        self, obj: Any, type_in: Any = None
    ) -> BoundBAMasterMessageSender:
        return BoundBAMasterMessageSender(obj, self)


class BoundBAMasterMessageSender(BoundMessageSender):
    """Protocol-specific bound sender."""

    @overload
    async def send_async(
        self, message: ForwardedClientMessage
    ) -> ForwardedClientResponse: ...

    @overload
    async def send_async(
        self, message: LoginProxyRequestInternalMessage
    ) -> LoginProxyRequestInternalResponse: ...

    @overload
    async def send_async(
        self, message: LoginProxyStateQueryInternalMessage
    ) -> LoginProxyStateQueryInternalResponse: ...

    @overload
    async def send_async(
        self, message: LoginProxyCompleteInternalMessage
    ) -> None: ...

    @overload
    async def send_async(
        self, message: AccountSessionReleaseInternalMessage
    ) -> None: ...

    @overload
    async def send_async(
        self, message: AccountSessionRegisterChannelMessage
    ) -> AccountSessionRegisterChannelResponse: ...

    @overload
    async def send_async(
        self, message: GetTestCloudBuildModeMessage
    ) -> StringResponse: ...

    @overload
    async def send_async(
        self, message: AccountSessionDeleteChannelsMessage
    ) -> None: ...

    @overload
    async def send_async(self, message: LogMessage) -> None: ...

    @overload
    async def send_async(self, message: ServerNodeStatsMessage) -> None: ...

    @overload
    async def send_async(self, message: TestCommResponseMessage) -> None: ...

    @overload
    async def send_async(
        self, message: ServerNodeStatsSparseMessage
    ) -> None: ...

    @overload
    async def send_async(
        self, message: SignInInternalMessage
    ) -> SignInInternalResponse: ...

    @overload
    async def send_async(
        self, message: CloudFilesExistQueryMessage
    ) -> CloudFilesExistQueryResponse: ...

    @overload
    async def send_async(self, message: CloudBuildResultsMessage) -> None: ...

    def send_async(self, message: Message) -> Awaitable[Response | None]:
        """Send a message asynchronously."""
        return self._sender.send_async(self._obj, message)
