# Released under the MIT License. See LICENSE for details.
#
"""Auto-generated sender module. Do not edit by hand."""

from __future__ import annotations

from typing import TYPE_CHECKING, overload

from efro.message import MessageSender, BoundMessageSender

if TYPE_CHECKING:
    from typing import Any, Awaitable
    from baserver.msg.cloudtoba import (
        BToCMsg1,
        BToCMsg2,
        TransportAgentShutdownWarningMessage,
        TokenInvalidatedMessage,
        BToCResp1,
        BToCResp2,
        CloudConsoleUpdateResponse,
    )
    from efro.message import Message, Response


class ClientMessageSender(MessageSender):
    """Protocol-specific sender."""

    def __init__(self) -> None:
        from baserver.msg.cloudtoba import get_basn_to_client_protocol_basn

        protocol = get_basn_to_client_protocol_basn()
        super().__init__(protocol)

    def __get__(
        self, obj: Any, type_in: Any = None
    ) -> BoundClientMessageSender:
        return BoundClientMessageSender(obj, self)


class BoundClientMessageSender(BoundMessageSender):
    """Protocol-specific bound sender."""

    @overload
    async def send_async(self, message: BToCMsg1) -> BToCResp1: ...

    @overload
    async def send_async(self, message: BToCMsg2) -> BToCResp1 | BToCResp2: ...

    @overload
    async def send_async(
        self, message: TransportAgentShutdownWarningMessage
    ) -> None: ...

    @overload
    async def send_async(self, message: TokenInvalidatedMessage) -> None: ...

    def send_async(self, message: Message) -> Awaitable[Response | None]:
        """Send a message asynchronously."""
        return self._sender.send_async(self._obj, message)
