"""BASN functionality for running subtasks."""

from __future__ import annotations

from efro.util import set_canonical_module_names
from basn.taskwrapper._taskwrapper import (
    StandardAction,
    BaseTaskWrapper,
)
from basn.taskwrapper._inline import InlineTaskWrapper
from basn.taskwrapper._standalone import StandaloneTaskWrapper
from basn.taskwrapper._sandbox import SandboxTaskWrapper

__all__ = [
    'StandardAction',
    'BaseTaskWrapper',
    'StandaloneTaskWrapper',
    'InlineTaskWrapper',
    'SandboxTaskWrapper',
]

# Have these things present themselves cleanly as 'somepackage.SomeClass'
# instead of 'somepackage._internalmodule.SomeClass'
set_canonical_module_names(globals())
