"""Functionality for wrangling tasks."""

from __future__ import annotations

from dataclasses import dataclass
from typing import TYPE_CHECKING

from efro.dataclassio import ioprepped
from baserver.enums import ServerNodeRunMode

from basntask.command import TaskCommand

if TYPE_CHECKING:
    pass


@ioprepped
@dataclass
class TaskEnv:
    """Data included when running a task."""

    ba_server_path: str | None
    run_mode: ServerNodeRunMode
    command: TaskCommand
